using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace MPThread
{
    /// <summary>
    /// Kerry D. Wong
    /// http://www.kerrywong.com
    /// </summary>
    public class PrimeGen
    {
        private int _startNumber = 0;
        private int _interval = 0;
        private int _limit = 0;

        public int StartNumber
        {
            get { return _startNumber; }
            set { _startNumber = value; }
        }

        public int Interval
        {
            get { return _interval; }
            set { _interval = value; }
        }

        public int Limit 
        {
            get { return _limit; }
            set { _limit = value; }
        }

        public PrimeGen(int startNumber, int interval, int limit)
        {
            _startNumber = startNumber;
            _interval = interval;
            _limit = limit;
        }

        public void Start()
        {
            for (int i = _startNumber; i <= _limit; i += _interval)
            {
                IsPrime(i);
            }
        }

        private bool IsPrime(int num)
        {
            for (int i = 3; i <= Math.Sqrt((double)num); i += 2)
            {
                if (num % i == 0)
                    return false;
            }

            return true;
        }
    }

    public class MPThreadingTest
    {
        private PrimeGen primeGen;
        private Thread t;

        public MPThreadingTest(int startNumber, int interval, int limit)
        {
            primeGen = new PrimeGen(startNumber, interval, limit);
        }

        public void Start()
        {
            ThreadStart del = new ThreadStart(primeGen.Start);
            t = new Thread(del);
            t.Start();
        }

        public void Wait()
        {
            t.Join();
        }
    }

}
