using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace MPThread
{
    /// <summary>
    /// Kerry D. Wong
    /// http://www.kerrywong.com
    /// </summary>
    class Program
    {
        private PerformanceCounter perfCounter = new PerformanceCounter();

        public double Run(int numOfThreads, int ubound)
        {
            MPThreadingTest[] threads = new MPThreadingTest[numOfThreads];

            int startNum = 3;

            for (int i = 0; i < numOfThreads; i++)
                threads[i] = new MPThreadingTest(startNum + i * 2, numOfThreads * 2, ubound - (numOfThreads - i) * 2);
   
            perfCounter.Start();

            for (int i = 0; i < numOfThreads; i++)
                threads[i].Start();

            for (int i = 0; i < numOfThreads; i++)
                threads[i].Wait();

            perfCounter.End();
            
            return perfCounter.TimeElapsed("MS");
        }

        static void Main(string[] args)
        {
            if (args.Length != 2)
            {
                Console.WriteLine("Usage: MPThread {number of threads} {upper bound}");
            }
            else
            {
                int numThreads = 0;
                bool r1 = int.TryParse(args[0], out numThreads);

                int ubound = 0;
                bool r2 = int.TryParse(args[1], out ubound);

                if ((!r1) || (!r2) )
                {
                    Console.WriteLine("Error: parameter is not integer");
                }
                else
                {
                    Program p = new Program();
                    Console.WriteLine("Time = " + p.Run(numThreads, ubound) + "ms");
                }
            }
        }
    }
}
